"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const operators_1 = require("rxjs/operators");
const log4js_constant_1 = require("./log4js.constant");
const log4js_1 = require("log4js");
let Log4jsInterceptor = class Log4jsInterceptor {
    constructor(requestLogger, responseLogger) {
        this.requestLogger = requestLogger;
        this.responseLogger = responseLogger;
    }
    intercept(context, call$) {
        const httpRequest = context.switchToHttp().getRequest();
        this.requestLogger.info(httpRequest);
        return call$.pipe(operators_1.tap(httpResponse => {
            this.responseLogger.info(httpResponse);
        }));
    }
};
Log4jsInterceptor = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(log4js_constant_1.LOG4JS_REQUEST_LOGGER)),
    __param(1, common_1.Inject(log4js_constant_1.LOG4JS_RESPONSE_LOGGER)),
    __metadata("design:paramtypes", [log4js_1.Logger,
        log4js_1.Logger])
], Log4jsInterceptor);
exports.Log4jsInterceptor = Log4jsInterceptor;
